# Einfacher Chat-Client auf der Konsole, der als Thread
# sowohl Nachrichten vom Server ausgibt, als auch Nachrichten
# an den Server (die anderen Teilnehmer) quasi zeitgleich versendet.
# Es erfolgt weder eine Pruefung, ob Server aktiv noch eine Abmeldung

import socket
from threading import Thread

# Port- und Hostkonstanten: bei Bedarf aendern
PORT=8000
HOST="127.0.0.1"

class Client(Thread):
    """Chat-Client auf der Kommandozeile"""
    def __init__(self, name, host=HOST, port=PORT):
        Thread.__init__(self)
        self.name = name
        self.host = host
        self.port = port
        # UDP-Socket
        self.s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
        # sende erste Nachricht an Chatserver
        self.s.sendto(self.name+" hat sich angemeldet",(self.host, self.port))

    def run(self):              # interne Startmethode des Threads
        while 1:                # Endlosschleife der Serverausgabe (100 Zeichen)
            print self.s.recvfrom(100)[0]

    def action(self):           # startet den Client, indem
        self.start()            # der Thread aufgerufen wird
        while 1:                # Endlosschleife des Nachrichtenversands
            self.s.sendto(self.name+": "+raw_input(),(self.host, self.port))

c = Client(name=raw_input("Dein Name: "))
c.action()
